/* HTMLParser.h */

#define END					-1
#define MAXLEXBUFFER		512

// Token List

/* EOF */
#define TK_EOF				0

/* Text 1 */
#define TK_TEXT				1

/* Tag 2 - 99 */
#define TK_TAG				2
#define TK_TAG_UNKNOWN		3
#define TK_TAG_B			4
#define TK_TAG_I			5
#define TK_TAG_U			6
#define TK_TAG_P			7
#define TK_TAG_A			8

#define TK_TAG_H1			10

/* ETag 100 - 199 */
#define TK_ETAG				100
#define TK_ETAG_UNKNOWN		101
#define TK_ETAG_B			102
#define TK_ETAG_I			103
#define TK_ETAG_U			104
#define TK_ETAG_P			105
#define TK_ETAG_A			106

#define TK_ETAG_H1			110

struct TOKEN {
	int id;
	char* p;
};

class CHTMLParser
{	
protected:
	int GetEvent(int c);
	int GetSpecialChar();
	void ErrorMessage(char* szMsg);
	void PrintOutput(int token);

public:
	CHTMLParser();
	int GetToken(TOKEN* pToken);
	bool Open(LPCTSTR input);
	void Close();
	
};