// HTMLViewerDoc.cpp : implementation of the CHTMLViewerDoc class
//

#include "stdafx.h"
#include "HTMLViewer.h"

#include "HTMLViewerDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHTMLViewerDoc

IMPLEMENT_DYNCREATE(CHTMLViewerDoc, CDocument)

BEGIN_MESSAGE_MAP(CHTMLViewerDoc, CDocument)
	//{{AFX_MSG_MAP(CHTMLViewerDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHTMLViewerDoc construction/destruction

CHTMLViewerDoc::CHTMLViewerDoc()
{
}

CHTMLViewerDoc::~CHTMLViewerDoc()
{
}

BOOL CHTMLViewerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CHTMLViewerDoc serialization

void CHTMLViewerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// CHTMLViewerDoc diagnostics

#ifdef _DEBUG
void CHTMLViewerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CHTMLViewerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHTMLViewerDoc commands

BOOL CHTMLViewerDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	DeleteContents();

	CHTMLParser parser;
	TOKEN token;
	CTokenInfo ti;

	if (!parser.Open(lpszPathName)) 
		return FALSE;
	
	ti.m_pWidths = NULL;

	while (parser.GetToken(&token) != TK_EOF) 
	{
		switch (token.id)
		{
			case TK_TEXT: 
				ti.SetText(token.p);
				m_tokens.AddTail(ti);
				ti.m_nStyle &= ~TI_NEWLINE;
				break;
			case TK_TAG_B: 
				ti.m_nStyle |= TI_BOLD; 
				break;
			case TK_ETAG_B: 
				ti.m_nStyle &= ~TI_BOLD;
				break;
			case TK_TAG_I: 
				ti.m_nStyle |= TI_ITALIC;
				break;
			case TK_ETAG_I: 
				ti.m_nStyle &= ~TI_ITALIC; 
				break;
			case TK_TAG_H1: 
				ti.m_nStyle |= TI_H1;
				ti.m_nStyle |= TI_NEWLINE;
				break;
			case TK_ETAG_H1: 
				ti.m_nStyle &= ~TI_H1;
				ti.m_nStyle |= TI_NEWLINE;
				break;
			case TK_TAG_P:
				ti.m_nStyle |= TI_NEWLINE;
				break;
			case TK_ETAG_P:
				ti.m_nStyle |= TI_NEWLINE;
				break;
			case TK_TAG_A:
				ti.m_nStyle |= TI_HYPERLINK;
				break;
			case TK_ETAG_A:
				ti.m_nStyle &= ~TI_HYPERLINK;
				break;
		}
	}

	parser.Close();

	/*POSITION pos = m_tokens.GetHeadPosition();
	CString str;
	FONTINFO aux;*/

	/*while(pos) {
		aux = m_tokens.GetNext(pos);
		str.Format("Token=%s, bold=%c, italic=%c", aux.m_pText, 
			(aux.m_bBold) ? 'S':'N', (aux.m_bItalic) ? 'S':'N');
		AfxMessageBox(str);
	}*/
	
	return TRUE;
}

void CHTMLViewerDoc::DeleteContents() 
{
	POSITION pos = m_tokens.GetHeadPosition();

	while(pos)
		m_tokens.GetNext(pos).Empty();

	m_tokens.RemoveAll();
	
	CDocument::DeleteContents();
}
