// tokeninfo.h

#define TI_TEXT			0		//0
#define TI_BOLD			2		//1
#define TI_ITALIC		4		//2
#define TI_UNDERLINE	8		//3
#define TI_H1			16		//4
#define TI_H2			32		//5
#define TI_H3			64		//6
#define TI_H4			128		//7
#define TI_H5			256		//8
#define TI_H6			512		//9
#define TI_MATH			1024	//10
#define TI_USERFONT		2048	//11
#define TI_NEWLINE		4096	//12
#define TI_HYPERLINK	8192	//13

class CTokenInfo 
{
public:
	char* m_pText;
	int*  m_pWidths;
	int   m_nHeight;
	int   m_nLen;
	int   m_nStyle;

public:
	CTokenInfo()
	{
		m_pText = NULL;
		m_pWidths = NULL;
		m_nHeight = 0;
		m_nLen = 0;
		m_nStyle = 0;
	}
	void SetText(const char* sz) 
	{
		ASSERT(sz != NULL);
		m_nLen = strlen(sz);
		
		// override the previous string if were
		// someone must delete it somewhere
		m_pText = new char[m_nLen]; 
		memcpy(m_pText, sz, m_nLen);
	}
	void Empty() {
		if (m_pText) delete[] m_pText;
		if (m_pWidths) delete[] m_pWidths;
		m_nLen = 0;
		m_nStyle = 0;
	}
};